(*  TMagnify for Borland Delphi& C++ Builder                                  *)
(*  version 2.0                                                               *)
(*  Copyright (c) 1998-2004  HongDi science & technology development co.,ltd. *)
(*         website : http://www.codeidea.com                                  *)
(*           forum : http://bbs.codeidea.com                                  *)
(*  support E-Mail : webmaster@codeidea.com                                   *)
(*  it is a freeware , anyone can publish it!                                 *)


unit Magnify;
{
notice
Original : do not change any time
FNovector: same size with screen showed  , no vector  shapes for Magnify
Fvector:same size with screenshowed,vector shapes include!
for  1. show  for eyes; 2.Magnify
}

interface
uses windows, Messages, Sysutils, classes, graphics, controls, forms, dialogs,
extCtrls, math, stdctrls, extdlgs,  jpeg;

type
  TMagnify = class(TGraphicControl)
    //class(TCustomcontrol)//
  private
    Origin, MovePt: TPoint;
    {MouseDown  Tag}
    MsDNTag: Byte; //MouseDown Tag
    {Magnify Parameter}
    ZHalf: Byte;
    ZZoom: Byte;
    FOnpaint: TNotifyEvent;
    FZoomed: Double;
    FOnRightClick: TNotifyEvent;
    FOriginal: TBitmap;
    FVector: TBitmap;

    FShowBorder: Boolean;
    FBorderColor: TColor;
    FAutoSize: Boolean;
    fAutoStretch: Boolean;

    procedure SetZZoom(const value: Byte);
    procedure SetZHalf(const value: Byte);
    procedure WMRButtonDown(var message: TwmrbuttonDown); message
      WM_RBUTTONDOWN;
    function IsPaletteDevice: Boolean;
    procedure SetUsePaletteDevice(const value: Boolean);

    procedure SetShowBorder(const Value: Boolean);
    procedure SetBordercolor(const Value: TColor);
    procedure SetAutoSize(const Value: boolean);
    procedure SetAutoStretch(const Value: Boolean);

  protected
    procedure Paint; override;
    procedure WMEraseBKgnd(var message: TWMEraseBKgnd); message WM_ERASEBKGND;
  public
     procedure mousemove(shift: TSHiftstate; x, y: Integer); override;
    procedure Mousedown(Button: TMouseButton; Shift: TShiftstate; x, y: Integer);
      override;
    procedure Mouseup(Button: TMouseButton; Shift: TShiftstate; x, y: Integer);
      override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Canvas;
    procedure SetBitMap(const value: Tbitmap);
    function LoadGraphicsFile(const Filename: string): TBitmap;
  published
    property Autosize: boolean read FAutoSize write SetAutosize;
    property Align;
    property Anchors;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ParentColor;
    property ParentShowHint;
    property PopupMenu;
    //property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnStartDock;
    property OnStartDrag;
    property Original: TBitmap read FOriginal write SetBitmap;
    property PaletteDevice: Boolean read IsPaletteDevice write
      SetUsePalettedevice;
    //property Zoomed:Double read fzoomed write setZoomed;
    property OnRightClick: TNotifyEvent read FOnRightClick write FOnRightClick;
    property MagSquare: byte read ZHalf write SetZHAlf;
    property MagZoom: Byte read ZZoom write SetZZoom;
    property ShowBorder: Boolean read FShowBorder write SetShowBorder;
    property BorderColor: TColor read FBorderColor write setBorderColor;
    property AutoStretch: Boolean read fAutoStretch write SetAutoStretch;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterCOmponents('codeidea', [TMagnify]);
end;

procedure SubRect(ARect, BRect: TRect; var VaRect, VbRect: Trect);
//ARect:Main BREctOther
var
  x1, y1, x2, y2, x3, y3, x4, y4: integer;
begin
  SetREctEmpty(Varect);
  SetREctEmpty(Vbrect);
  with AREct do
  begin x1 := Left;
    y1 := Top;
    X2 := Right;
    Y2 := Bottom;
  end;
  with BREct do
  begin x3 := Left;
    y3 := Top;
    X4 := Right;
    Y4 := Bottom;
  end;
  if (x3 < x2) and (x2 <= x4) and (y3 <= y1) and (y1 < y4) then
  begin
    varect := Rect(x1, y4, x2, y2);
    vbrect := Rect(x1, y1, x3, y4);
  end
  else
    if (x3 < x1) and (x1 < x4) and (y3 <= y1) and (y1 <= y4) then
    begin
      Varect := rect(x4, y1, x2, y4);
      Vbrect := rect(x1, y4, x2, y2);
    end
    else
      if (x3 < x1) and (x1 < x4) and (y3 <= y2) and (y2 <= y4) then
      begin
        Varect := rect(x1, y1, x2, y3);
        Vbrect := rect(x4, y3, x2, y2);
      end
      else
        if (x3 < x2) and (x2 <= x4) and (y3 <= y2) and (y2 <= y4) then
        begin
          Varect := rect(x1, y1, x2, y3);
          Vbrect := rect(x1, y3, x3, y2);
        end
        else
        begin
          //no jiaocha
          VArect := AREct;
          SetRectEmpty(VBRECT);
        end
end;

procedure SetCursorClipArea(const AREct: TREct; DeCreaseX: Integer = 0;
  DeCreaseY: integer = 0; HideCursor: Boolean = false);
var
  CursorClipArea: TRect;
begin
  if HideCursor then Screen.Cursor := crNone;
  with ARect do
  begin
    CursorClipArea := Bounds(Left, Top, Right - DecreaseX, Bottom - DeCreaseY);
    ClipCursor(@CursorClipArea);
  end;
end;

procedure ReleaseCursorClipArea();
begin
  ClipCursor(nil);
  Screen.Cursor := crDefault;
end;

function ExpandRect(AREct: TRect; Delta: integer): TRect;
begin
  Result := AREct;
  if not inflateRect(Result, delta, delta) then Result := AREct;
end;

function PttoAREct(RectLT, RectRB: Tpoint): TRect;
begin
  {Two Point combine to a reC}
  with result do
  begin
    Left := Min(RectLt.x, RectRB.x);
    Right := Max(RectLT.x, RectRB.x);
    Top := Min(RectLT.Y, RectRB.y);
    Bottom := Max(RectLT.y, RectRB.Y);
  end;
end;

function GetMRect(APoint: TPoint; ZoomedHalf: integer): TRect;
begin
  Result := ExpandRect(PtToARect(APoint, APoint), ZoomedHalf);
end;

function TMagnify.LoadGraphicsFile(const FileName: string): TBitmap;
var
  Extension: string;
  ICON: TIcon;
  JpegImagE: TJpegImage;
  MetaFile: TMetaFile;

begin
  REsult := nil;

  if FileExists(FileName)
    then
  begin
    Extension := UpperCase(Copy(FileName, Length(FileName) - 2, 3));
    if ((Extension = 'BMP') or
      (Extension = 'EMF') or
      (Extension = 'ICO') or
      (Extension = 'JPG') or
      (Extension = 'TIF') or
      (Extension = 'WMF')) then
    begin
      if Assigned(Result) then Result.Free;

      Result := TBitmap.Create;
   {   if Extension = 'TIF'
        then begin
         mTifBmp:= TTIFFBitMap.Create;
         mTifBmp.LoadFromTifFileEx(FileName);
         Result.Height :=mTifBmp.Height;
         Result.Width :=mTifBmp.Width;
         Result.Canvas.Draw(0,0,mTifBmp);
         mTifBmp.Destroy;
        end;
//        LoadTiffFromFile(Filename, Result); }

      if Extension = 'BMP'
        then Result.LoadFromFile(Filename);

      if Extension = 'ICO'
        then
      begin
        ICON := TIcon.Create;
        try
          try
            Icon.LoadFromFile(FileName);
            Result.Height := Icon.Height;
            RESULT.width := Icon.Height;
            RESULT.PixelFormat := pf24bit; //avoid palette problems
            RESULT.Canvas.Draw(0, 0, Icon)
          except
            //Ignore problem icons,e.g.,stream read errors
          end;
        finally
          Icon.Free
        end
      end;
      //JPG File
      if Extension = 'JPG'
        then
      begin
        JPEGImage := TJPEGImage.Create;
        try
          JPEGImage.LoadFromFILE(Filename);
          RESULT.Height := JPEGImage.Height;
          result.Width := JPEGImage.Width;
          RESULT.PixelFormat := pf24bit;
          RESULT.Canvas.Draw(0, 0, JPEGImage);
        finally
          JPEGImage.Free
        end
      end;
      //Windows Metafiles,WMF or EMF
      if (Extension = 'WMF') or (Extension = 'EMF')
        then
      begin
        metafile := TMetafile.Create;
        try
          Metafile.loadfromFile(Filename);
          RESULT.Height := Metafile.Height;
          RESULT.Width := Metafile.width;
          RESULT.Pixelformat := pf24bit; //avoid palette problems
          RESULT.Canvas.Draw(0, 0, Metafile)
        finally
          metafile.Free
        end
      end;
    end
  end;
  //IF GRAphic is missing or invalid,
  if RESULT = nil
    then
  begin
    RESULT := TBitmap.Create;
    RESULT.Height := Height;
    RESULT.Width := width;
    RESULT.Pixelformat := pf24bit;
  end;
end {(LoadGraphicfile);}
;

procedure TMagnify.WMRBUttonDown(var Message: TWMRButtonDown);
begin
  inherited;
  if Assigned(FOnRightclick) then FOnRightClick(self);
end;

constructor TMagnify.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  MsDnTag := 0; //MouseDown Tag
  controlstyle := controlstyle + [csReplicatable] + [csopaque]; //+
  width := 105;
  Height := 105;
  // Fkx:=1.00;
  FZoomed := 1.0;
  FOriginal := TBitmap.create;
  FVector := TBitmap.Create;
  {Magnify parameter}
  zhalf := 20;
  zzoom := 2;
  FBordercolor := clwhite;
  FAutosize := true;
  fAutoStretch := false;
end;

destructor TMagnify.Destroy;
begin
  try
    FOriginal.Free;
    FVector.Free;

  except
  end;
  inherited Destroy;
end;

function TMagnify.IsPaletteDevice: Boolean;
var
  DeviceContext: hDC;
begin
  DeviceContext := GetDC(0);
  try
    RESULT := GetDeviceCaps(DeviceContext, RASTERCAPS) and RC_PALETTE =
      RC_PALETTE
  finally
    ReleaseDC(0, DeviceContext)
  end
end;

procedure TMagnify.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0; //1
end;

procedure TMagnify.Paint;
begin
  ControlStyle := ControlStyle + [csReplicatable] - [csopaque]; // +

  if csDesigning in ComponentState then
    with Canvas do
    begin
      Pen.Style := psDash;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
    end;
  if Assigned(FOnPaint) then FOnPaint(Self);

  Canvas.StretchDraw(Rect(0, 0, Width, Height), FOriginal);

  ControlStyle := ControlStyle + [csReplicatable] + [csopaque]; // +

end;

procedure TMagnify.SetUsePaletteDevice(const Value: Boolean);
begin
end;

procedure TMagnify.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  // Tmpbmp:TBitmap;

  tmpRect: TRect;
begin
  inherited MouseDown(Button, Shift, X, Y);
  if Button = mbRight then exit;
  if (FOriginal.Width <> 0) and (FOriginal.Height <> 0) then //no file load
  begin
    Origin := Point(x, y);
    Movept := Origin;
    MsDnTag := 9; //Set Enable Flag;

    with FVector do
    begin
      Width := Self.Width;
      Height := self.Height;
    end;
    tmpRect := GetMRect(Point(x, y), Trunc(Zhalf * ZZoom));
    FVector.Canvas.CopyRect(Rect(0, 0, Width, Height), Canvas, Rect(0, 0, Width,
      Height));
    SetCursorClipArea(Rect(ClientOrigin.x, ClientOrigin.y, FVector.Width,
      FVector.Height),
      trunc(Zhalf * ZZoom / 2), trunc(Zhalf * ZZoom / 2), True);
    Canvas.CopyRect(tmpRect, Fvector.Canvas, {*fori*} GetMRect(Origin, Zhalf));
    if FShowBorder then
    begin
      Canvas.Brush.Color := clWhite;
      Canvas.FrameRect(tmprect);
    end;
  end;
end;

procedure TMagnify.Mousemove(Shift: TShiftState; X, Y: Integer);
var
  TArect, tmpRect, TBRect: TRect; //Temp rect
begin
  if MsDnTag = 9 then
  begin
    // Restore
    SubRect(GetMRect(Origin, Trunc(Zhalf * ZZoom)), GetMRect(Point(x, y),
      Trunc(Zhalf * ZZoom)), TArect, TBRect);
    if not IsRectEmpty(TArect) then
      Canvas.CopyRect(TArect, FVector.Canvas, TARect);
    if not IsRectEmpty(TBrect) then
      Canvas.CopyRect(TBrect, FVector.Canvas, TBRect);
    // Zoom
    tmpRect := GetMRect(Point(x, y), Trunc(Zhalf * ZZoom));
    Canvas.CopyRect(tmpRect, Fvector.Canvas {FOriginal.canvas},
      GetMRect(Point(x, y), Zhalf));
    //Regsiter Code
    Canvas.Font.Color := clRed;

    //       Inflaterect(tmpRect,-1,-1);
    if FShowBorder then
    begin

      Canvas.Brush.Color := FBorderColor;
      Canvas.FrameRect(tmprect);
    end;
    Origin := Point(x, y);
  end;
end;

procedure TMagnify.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y:
  Integer);
begin
  if MsDnTag = 9 then //MouseUp
  begin //Restore
    ReleaseCursorClipArea();
    Canvas.CopyRect(GetMRect(Point(x, y), Trunc(Zhalf * zzoom)),
      FVector.Canvas,
      GetMRect(Point(x, y), Trunc(Zhalf * zzoom)));
  end;
  MsDnTag := 0;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TMagnify.SetBitmap(const Value: TBitmap);
begin

  if FAutoSize then
  begin
    FOriginal.Assign(Value);
    Width := FOriginal.width;
    Height := FOriginal.Height;
  end
  else
  begin
    if FAutoStretch then
    begin
      FOriginal.Width := Width;
      FOriginal.Height := Height;
      FOriginal.Canvas.StretchDraw(Rect(0, 0, Width, Height), value);
    end

  end;

  Paint;
end;

procedure TMagnify.SetZZoom(const Value: byte);
begin
  ZZoom := Value;
end;

procedure TMagnify.SetZHalf(const Value: byte);
begin
  ZHalf := Value;
end;

procedure TMagnify.SetShowBorder(const Value: Boolean);
begin
  FShowBorder := Value;
end;

procedure TMagnify.SetBorderColor(const Value: TColor);
begin
  FBorderColor := Value;
end;

procedure TMagnify.SetAutoSize(const Value: boolean);
begin
  FAutoSize := Value;
  try
    if FAutoSize and (FOriginal.Width > 0) and (FOriginal.Height > 0) then
    begin
      fAutoStretch := false;
      SetBounds(Left, Top, FOriginal.Width, FOriginal.Height);
      paint;
    end
    else
      if not FAutoSize then
        fAutoStretch := true;
  except
  end;
end;

procedure TMagnify.SetAutoStretch(const Value: Boolean);
begin
  fAutoStretch := Value;
  if fAutoStretch then
    FAutoSize := false
  else
    FAutoSize := true;
  ;
end;

end.

