unit JanHDBGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Grids, DBGrids;

type
  TJanHDBGrid = class(TDBGrid)
  private
    FLines: integer;
    FGetGridFocus: boolean;
    function GetGridFocus: boolean;
  protected
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property MoveByRows: integer read FLines write FLines;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
  end;

procedure Register;

implementation

constructor TJanHDBGrid.Create(AOwner: TComponent);
begin
   FLines:=1;
   inherited;
end;

destructor TJanHDBGrid.Destroy;
begin
  inherited;
end;

function TJanHDBGrid.GetGridFocus: Boolean;
begin
  Result := True;
  if FGetGridFocus and CanFocus and (not (csDesigning in ComponentState)) then begin
    if not Self.Focused then Self.SetFocus;
    Result := Focused;
  end;
end;

function TJanHDBGrid.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(OnMouseWheelDown) then OnMouseWheelDown(Self, Shift, MousePos, Result);
  if not Result then
    begin
      if not GetGridFocus then Exit;
      if DataLink.Active then begin
       Result := DataLink.DataSet.MoveBy(FLines) <> 0;
      end;
    end;
end;

function TJanHDBGrid.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(OnMouseWheelUp) then OnMouseWheelUp(Self, Shift, MousePos, Result);
  if not Result then
    begin
      if not GetGridFocus then Exit;
      if DataLink.Active then begin
        Result := DataLink.DataSet.MoveBy(-FLines) <> 0;
      end;
    end;
end;

procedure Register;
begin
  RegisterComponents('Data Controls', [TJanHDBGrid]);
end;

end.
